USE AdventureWorks
GO

--DROP TABLE person.contact2

select * from Person.Contact

select * INTO person.contact2
from person.Contact


CREATE CLUSTERED INDEX [cl_idx_contactID] ON [Person].[contact2] 
(
	[ContactID]
)


CREATE NONCLUSTERED INDEX [ncl_idx_EmailPromotion] ON [Person].[contact2] 
(
	[EmailPromotion]
)


-- Review your index list
EXEC sp_helpindex [person.contact2]
go


SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE c.FirstName LIKE 'L%'					
        AND c.EmailPromotion = 1		
        AND c.ContactID < 10000			
OPTION (MAXDOP 1)
go



--------------------------------------------------------------
SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE c.FirstName LIKE 'L%'				
        --AND c.c.EmailPromotion = 1		
        --AND c.ContactID < 10000		
OPTION (MAXDOP 1)
go

-- DBCC FREEPROCCACHE

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE
--WHERE c.FirstName LIKE 'L%'					
        c.EmailPromotion = 1		
        --AND c.ContactID < 10000			
OPTION (MAXDOP 1)
go

-- DBCC FREEPROCCACHE

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE
--WHERE c.FirstName LIKE 'L%'					
        --AND c.c.EmailPromotion = 1		
        c.ContactID < 10000				
OPTION (MAXDOP 1)
go




CREATE INDEX ncl_idx_FirstName ON [Person].[contact2] 
(
	[FirstName]
)
go


-- drop index ncl_idx_FirstName ON [Person].[contact2]



-- let us compare

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(1))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(0))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go




-- let us compare




SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(1))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go





-- let us compare the current plan with previous 2


SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(1))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(ncl_idx_FirstName, ncl_idx_EmailPromotion))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

-- No hints, SQL Server can do whatever it wants :)
SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go



-----options with other covering indexes


CREATE INDEX ContactCovering2 
ON Person.Contact2(EmailPromotion, firstname, contactID)


CREATE INDEX ContactCovering3
ON Person.Contact2(contactID, EmailPromotion, firstname)




-- let us compare


SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(1))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(ncl_idx_FirstName, ncl_idx_EmailPromotion))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go


SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(ContactCovering3))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go


SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c WITH (INDEX(ContactCovering))
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

-- No hints, SQL Server can do whatever it wants :)
SELECT c.ContactID, c.FirstName, c.EmailPromotion
FROM person.Contact2 AS c
WHERE c.FirstName LIKE 'L%'
        AND c.EmailPromotion = 1
        AND c.ContactID < 10000
OPTION (MAXDOP 1)
go

