USE AdventureWorks
GO

--DROP TABLE person.contact2

select * from Person.Contact

-- create a duplicate table
select * INTO person.contact2
from person.Contact

-- create the indexes
CREATE CLUSTERED INDEX [cl_idx_contactID] ON [Person].[contact2] 
(
	[ContactID]
)

CREATE INDEX ix_Customer_Name
ON Person.Contact2(LastName, FirstName);


--select * from Person.contact2

-- query 1

SELECT LastName, FirstName, EmailAddress
FROM Person.contact2
WHERE LastName = 'Abel' AND FirstName = 'Heather';

-- query 2 (reverse the predicates)

SELECT LastName, FirstName, EmailAddress
FROM Person.contact2
WHERE FirstName = 'Heather' AND LastName = 'Abel'


-- only one column
SELECT LastName, FirstName, EmailAddress
FROM Person.contact2
WHERE LastName = 'Abel'


-- now, what if we take the other column
SELECT LastName, FirstName, EmailAddress
FROM Person.contact2
WHERE FirstName = 'Heather'

-- SET STATISTICS IO ON

DROP INDEX ix_Customer_Name
ON Person.Contact2

-- index is still useful

SELECT LastName, FirstName, EmailAddress
FROM Person.contact2
WHERE FirstName = 'Heather'


